## openmodelica 8719

=== CMakeLists.txt ===
# Jens Frenkel, Jens.Frenkel@tu-dresden.de, 2010-03-30
# CMakefile for compilation of OMC 

# CMAKE
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
# PROJECT
PROJECT(OpenModelicaCompiler)

# Global Variables
SET(OMCTRUNCHOME ${CMAKE_CURRENT_SOURCE_DIR})
SET(CODEGENDIR ${CMAKE_CURRENT_BINARY_DIR}/codegen)

# Tests
OPTION(RUN_TESTS  "Run Tests"  OFF)
IF(RUN_TESTS)
enable_testing()
ADD_SUBDIRECTORY(testsuite)
ENDIF(RUN_TESTS)

# Subdirectorys
ADD_SUBDIRECTORY(c_runtime)
#ADD_SUBDIRECTORY(modelica_parser)
#ADD_SUBDIRECTORY(flat_modelica_parser)
#ADD_SUBDIRECTORY(Compiler)
#ADD_SUBDIRECTORY(doc)
#ADD_SUBDIRECTORY(Examples)

# -------------------------------------------------------------
# Models
# -------------------------------------------------------------
# add here your models to compile (add filename without ".mo")
# Example:
#    BUILDMODEL(model dir Flags CSRC)
SET(OMC_DEBUG ${OMCTRUNCHOME}/build/bin/omc.exe)
#BUILDMODEL(BouncingBall ${CMAKE_CURRENT_SOURCE_DIR}/testsuite/mosfiles-dassl +d=bltdump "")
#BUILDMODEL(Simple ${CMAKE_CURRENT_SOURCE_DIR}/build/bin/Test +d=bltdump)
#BUILDMODEL(WheelLoader_der_state ${CMAKE_CURRENT_SOURCE_DIR}/build/bin/Test +d=bltdump "")
#BUILDMODELFMU(Test ${CMAKE_CURRENT_SOURCE_DIR}/build/bin/Test/FMU +d=bltdump "")
#BUILDMODEL(Test1 ${CMAKE_CURRENT_SOURCE_DIR}/build/bin/Test/FMU +d=bltdump "")
BUILDMODELFMUMOS(WheelLoader D:/Programming/Models/Radlader/radlader-cnh/WheelLoader.mos +d=bltdump "")

=== Compiler/CMakeLists.txt ===

# The MO sources
SET(SRCMO Absyn.mo AbsynDep.mo Algorithm.mo Builtin.mo 
          Ceval.mo CevalScript.mo ClassInf.mo
		  ClassLoader.mo Connect.mo ExpandableConnectors.mo 
		  ConnectionGraph.mo Convert.mo DAE.mo DAELow.mo 
		  DAEUtil.mo Derive.mo Debug.mo	DFA.mo Dump.mo 
		  DumpGraphviz.mo Constants.mo Env.mo Error.mo 
		  Exp.mo SCode.mo SCodeUtil.mo Graphviz.mo HashTable.mo 
		  HashTable2.mo HashTable3.mo HashTable4.mo HashTable5.mo 
		  HashTable6.mo HashTableCG.mo HashTableStringToPath.mo 
		  Inline.mo Inst.mo InstExtends.mo Interactive.mo 
		  Lookup.mo Main.mo MMath.mo MetaUtil.mo Mod.mo ModUtil.mo 
		  PartFn.mo Patternm.mo Prefix.mo PrefixUtil.mo Static.mo 
		  SimCode.mo SimCodeC.mo SimCodeCSharp.mo 
		  Types.mo TaskGraph.mo Tpl.mo TplAbsyn.mo TplCodegen.mo 
		  TplParser.mo TplMain.mo Util.mo UnitAbsyn.mo 
		  UnitAbsynBuilder.mo UnitChecker.mo Values.mo ValuesUtil.mo 
		  VarTransform.mo BackendVarTransform.mo Refactor.mo 
		  DAEQuery.mo XMLDump.mo InstanceHierarchy.mo InnerOuter.mo 
		  ConnectUtil.mo Dependency.mo)

SET(ALLMO ${SRCMO} DAEEXT.mo DynLoad.mo Print.mo RTOpts.mo System.mo Parser.mo 
		TaskGraphExt.mo Corba.mo Socket.mo ErrorExt.mo Settings.mo 
		OptManager.mo UnitParserExt.mo SimulationResults.mo)
		  
# RML
IF(NOT RML)
  FIND_PROGRAM(RML rml DOC "Location of the RML executable"
               PATHS ENV OMDEV ${RMLHOME}/bin
               PATH_SUFFIXES bin tools/rml/bin)
  MESSAGE(STATUS "-- rml is " ${RML})
ENDIF(NOT RML)		  

#copy all to CODEGENDIR
FOREACH(DEP ${ALLMO})

	# Datei- und Pfadname
    GET_FILENAME_COMPONENT(DF ${DEP} NAME)
    GET_FILENAME_COMPONENT(DFWE ${DEP} NAME_WE)
    GET_FILENAME_COMPONENT(DP ${DEP} PATH)

	# Suchen
	FIND_FILE(${DEP}_FILE ${DF} PATHS ${DP} ${CMAKE_CURRENT_SOURCE_DIR})

	# Wenn nicht gefunden, dann Original nehmen
	STRING(COMPARE EQUAL ${${DEP}_FILE} ${DEP}_FILE-NOTFOUND FF)
	IF(${FF})
		SET(${DEP}_FILE "\"${DEP}\"")
	ENDIF(${FF})
 
 	SET(COPY_DEP  ${${DEP}_FILE})

	SET(COPY_OUTPUT  ${CODEGENDIR}/${DEP})
	# custom command for copy
	ADD_CUSTOM_COMMAND(OUTPUT ${COPY_OUTPUT}
                     COMMAND ${CMAKE_COMMAND} -E copy ${COPY_DEP} ${COPY_OUTPUT}
					 DEPENDS ${COPY_DEP}
                     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                     COMMENT "copy ${COPY_DEP} to ${COPY_OUTPUT}")

  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${DFWE}_cp ALL DEPENDS ${COPY_OUTPUT})
  
  # remember
  SET(COPY_ALL ${COPY_ALL} ${COPY_OUTPUT})
ENDFOREACH(DEP)

#.depend:
SET(DEPENDT_OUTPUT  ${CODEGENDIR}/.depend)
# custom command for rml to sig
ADD_CUSTOM_COMMAND(OUTPUT ${DEPENDT_OUTPUT}
                   COMMAND ${RML} -fdump-depends ${SRCMO} > .depend 	
                   DEPENDS ${COPY_ALL}
                   WORKING_DIRECTORY ${CODEGENDIR}
                   COMMENT "Generate .depend")

# target fuer OM_OUTPUT
ADD_CUSTOM_TARGET(depend ALL DEPENDS ${DEPENDT_OUTPUT})
  

# generate sig files
FOREACH(DEP ${ALLMO})

	# Datei- und Pfadname
    GET_FILENAME_COMPONENT(DF ${DEP} NAME)
    GET_FILENAME_COMPONENT(DFWE ${DEP} NAME_WE)
 
	# Merken
	SET(SIG_DEP ${DFWE}.sig)
  
  SET(SIGX_OUTPUT  ${CODEGENDIR}/${SIG_DEP})
  # custom command for rml to sig
  ADD_CUSTOM_COMMAND(OUTPUT ${SIGX_OUTPUT}
                     COMMAND ${RML} -fdump-interface ${DEP} > ${SIG_DEP}  	
					 DEPENDS ${DEPENDT_OUTPUT}
                     WORKING_DIRECTORY ${CODEGENDIR}
                     COMMENT "Generate Sigx from ${DF}")

  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${DFWE}_sig ALL DEPENDS ${SIGX_OUTPUT})
  
    # remember
  SET(SIGX_ALL ${SIGX_ALL} ${SIGX_OUTPUT} )
ENDFOREACH(DEP)

# generate *.h and *.c from *.mo files
FOREACH(DEP ${SRCMO})

	# Datei- und Pfadname
    GET_FILENAME_COMPONENT(DF ${DEP} NAME)
    GET_FILENAME_COMPONENT(DFWE ${DEP} NAME_WE)
 
	# Merken
	SET(MOCH_DEP ${CODEGENDIR}/${DFWE}.h ${CODEGENDIR}/${DFWE}.c)
  
  SET(MOCH_OUTPUT  ${MOCH_DEP})
  # custom command for rml to sig
  ADD_CUSTOM_COMMAND(OUTPUT ${MOCH_OUTPUT}
                     COMMAND ${RML} -Eplain -ftrace ${RMLCFLAGS} ${DEP} 	
					 DEPENDS ${SIGX_ALL}
                     WORKING_DIRECTORY ${CODEGENDIR}
                     COMMENT "Generate *.h and *.c from ${DEP}")

  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${DFWE}_codegen ALL DEPENDS ${MOCH_OUTPUT})
  
  # remember
  SET(MOCH_ALL ${MOCH_ALL} ${MOCH_OUTPUT})
  SET(MOCH_codegen_ALL ${MOCH_codegen_ALL} ${DFWE}_codegen)
ENDFOREACH(DEP)

ADD_SUBDIRECTORY(runtime)
ADD_SUBDIRECTORY(absyn_builder)
ADD_SUBDIRECTORY(modpar)

if(WIN32)
INCLUDE_DIRECTORIES($ENV{OMDEV}/tools/rml/include/plain)
link_directories($ENV{OMDEV}/lib/antlr-win32-msvc/md-mdd ${OMCTRUNCHOME}/Compiler/runtime/lpsolve/lib/win32)
link_directories($ENV{OMDEV}/tools/rml/lib/plain)
#link_directories(D:/Programming/OPENMODELICA/buildmmc/runtime/plain/RelWithDebInfo)
else(WIN32)
INCLUDE_DIRECTORIES(${RMLHOME}/include/plain)
link_directories(${RMLHOME}/lib/plain)
endif(WIN32)
INCLUDE_DIRECTORIES(${CODEGENDIR})

# mico und benoetigte Bibliotheken
IF(WIN32)
  SET(platform_libs optimized mico2313 debug mico2313d optimized antlr debug antlrd)
ELSE(WIN32)
  SET(platform_libs mico2.3.13 optimized antlr debug antlrd) #ssl pthread)
ENDIF(WIN32)
# omc program

#add_definitions(/Ob2 /Ox /O2 /Ot /Oy /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_MBCS" /FD /EHsc /MT /W3 /nologo /c /TC /wd4311 /wd4312)
if(WIN32)
add_definitions(/D "_CRT_SECURE_NO_WARNINGS" /D "_CONSOLE")
endif(WIN32)
ADD_EXECUTABLE(omc ${MOCH_ALL})
if(WIN32)
TARGET_LINK_LIBRARIES(omc absyn_builder libmodpar sendData c_runtime wsock32 shlwapi)
TARGET_LINK_LIBRARIES(omc  rml)
else(WIN32)
TARGET_LINK_LIBRARIES(omc absyn_builder libmodpar sendData c_runtime runtime optimized lpsolve55 debug lpsolve55d ${platform_libs})
TARGET_LINK_LIBRARIES(omc rml)
endif(WIN32)

# install
INSTALL(TARGETS omc 
        RUNTIME DESTINATION bin)

=== c_runtime/CMakeLists.txt ===
# includes
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

# OMC Compiler
SET(OMC_DEBUG ${OMCTRUNCHOME}/build/bin/omcd.exe)
MESSAGE(" omc is " ${OMC_DEBUG})

ADD_SUBDIRECTORY(libf2c)
ADD_SUBDIRECTORY(sendData)
ADD_SUBDIRECTORY(ModelicaExternalC)

# -------------------------------------------------------------
# MACRO definitions
# -------------------------------------------------------------

# Macros to hide/show cached variables.
# These two macros can be used to "hide" or "show" in the
# list of cached variables various variables and/or options 
# that depend on other options.
# Note that once a variable is modified, it will preserve its
# value (hidding it merely makes it internal)

MACRO(HIDE_VARIABLE var)
  IF(DEFINED ${var})
    SET(${var} "${${var}}" CACHE INTERNAL "")
  ENDIF(DEFINED ${var})
ENDMACRO(HIDE_VARIABLE)

MACRO(SHOW_VARIABLE var type doc default)
  IF(DEFINED ${var})
    SET(${var} "${${var}}" CACHE "${type}" "${doc}" FORCE)
  ELSE(DEFINED ${var})
    SET(${var} "${default}" CACHE "${type}" "${doc}")
  ENDIF(DEFINED ${var})
ENDMACRO(SHOW_VARIABLE)

# MACRO BUILDMODEL
MACRO(BUILDMODEL model dir Flags CSRC)

  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/c_runtime)

  # Variablen fuer openmodelica2sarturis
  SET(OMC_CODE   ${CMAKE_CURRENT_BINARY_DIR}/${model}.cpp
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt)
  SET(OMC_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${model}.cpp
  #               ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.h
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_records.c)

  # custom command fuer openmodelicacompiler
  ADD_CUSTOM_COMMAND(OUTPUT ${OMC_OUTPUT}
                     COMMAND ${OMC_DEBUG} ${Flags} +s ${dir}/${model}.mo Modelica ModelicaServices 												  
                     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                     COMMENT "Erzeuge Code fuer ${model} with ${OMC_DEBUG}")

  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${model}codegen ALL DEPENDS ${OMC_OUTPUT})

  ADD_EXECUTABLE(${model} ${OMC_OUTPUT} ${CSRC})
  TARGET_LINK_LIBRARIES(${model} sim c_runtime f2c sendData ModelicaExternalC)

  # Dependencies
  ADD_DEPENDENCIES(${model} ${model}codegen)
  
  IF(MODELS_INSTALL)
    INSTALL(TARGETS ${model} RUNTIME DESTINATION ${MODELS_INSTALL_PATH})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt DESTINATION ${MODELS_INSTALL_PATH})
  ENDIF(MODELS_INSTALL)
#ENDFOREACH(model ${model_sources})
ENDMACRO(BUILDMODEL)

# MACRO BUILDMODEL
MACRO(BUILDMODELMOS model mos Flags CSRC)

  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/c_runtime)

  SET(OMC_MODELNAME ${model})  
  # generate model.mos 
  
  # Variablen fuer openmodelica2sarturis
  SET(OMC_CODE   ${CMAKE_CURRENT_BINARY_DIR}/${model}.cpp
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt)
  SET(OMC_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${model}.cpp
  #                ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.h
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_records.c)
  # custom command fuer openmodelicacompiler
  ADD_CUSTOM_COMMAND(OUTPUT ${OMC_OUTPUT}
                     COMMAND ${OMC_DEBUG} ${Flags} ${mos}
                     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                     COMMENT "Erzeuge Code fuer ${model} with ${OMC_DEBUG}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${model}codegen ALL DEPENDS ${OMC_OUTPUT})

 
  ADD_EXECUTABLE(${model} ${OMC_OUTPUT} ${CSRC})
  TARGET_LINK_LIBRARIES(${model} sim c_runtime f2c sendData ModelicaExternalC)

  # Dependencies
  ADD_DEPENDENCIES(${model} ${model}codegen)
  
  IF(MODELS_INSTALL)
    INSTALL(TARGETS ${model} RUNTIME DESTINATION ${MODELS_INSTALL_PATH})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/modelDescription.xml DESTINATION ${MODELS_INSTALL_PATH})
  ENDIF(MODELS_INSTALL)
#ENDFOREACH(model ${model_sources})
ENDMACRO(BUILDMODELMOS)

# MACRO BUILDMODEL
MACRO(BUILDMODELFMU model dir Flags CSRC)

  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/c_runtime)

  SET(OMC_MODELNAME ${model})  
  SET(OMC_MODELDIR ${dir})  
  # generate model.mos 
  FIND_FILE(MOSFILE_IN model_fmu.in PATHS ${OMCTRUNCHOME}/c_runtime)
  CONFIGURE_FILE(${MOSFILE_IN} ${dir}/${model}_FMU.mos)
  
  # Variablen fuer openmodelica2sarturis
  SET(OMC_CODE   ${CMAKE_CURRENT_BINARY_DIR}/${model}.cpp
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt)
  SET(OMC_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${model}.cpp
                  ${CMAKE_CURRENT_BINARY_DIR}/${model}_FMU.cpp
  #               ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.h
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_records.c)
  # custom command fuer openmodelicacompiler
  ADD_CUSTOM_COMMAND(OUTPUT ${OMC_OUTPUT}
                     COMMAND ${OMC_DEBUG} ${Flags} ${dir}/${model}_FMU.mos
                     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                     COMMENT "Erzeuge Code fuer ${model} with ${OMC_DEBUG}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${model}codegen ALL DEPENDS ${OMC_OUTPUT})

  SET(OMC_FMU_CODE ${OMCTRUNCHOME}/c_runtime/fmu_model_interface.h
                   ${OMCTRUNCHOME}/c_runtime/fmiModelFunctions.h
				   ${OMCTRUNCHOME}/c_runtime/fmiModelTypes.h)
  
  ADD_LIBRARY(${model} SHARED ${OMC_OUTPUT} ${CSRC} ${OMC_FMU_CODE})
  TARGET_LINK_LIBRARIES(${model} sim c_runtime f2c sendData ModelicaExternalC)

  # Dependencies
  ADD_DEPENDENCIES(${model} ${model}codegen)
  
  IF(MODELS_INSTALL)
    INSTALL(TARGETS ${model} ARCHIVE DESTINATION ${MODELS_INSTALL_PATH})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt DESTINATION ${MODELS_INSTALL_PATH})
  ENDIF(MODELS_INSTALL)
#ENDFOREACH(model ${model_sources})
ENDMACRO(BUILDMODELFMU)

# MACRO BUILDMODEL
MACRO(BUILDMODELFMUMOS model mos Flags CSRC)

  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/c_runtime)

  SET(OMC_MODELNAME ${model})  
  # generate model.mos 
  
  # Variablen fuer openmodelica2sarturis
  SET(OMC_CODE   ${CMAKE_CURRENT_BINARY_DIR}/${model}.cpp
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt)
  SET(OMC_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${model}.cpp
                  ${CMAKE_CURRENT_BINARY_DIR}/${model}_FMU.cpp
  #               ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.h
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_records.c)
  # custom command fuer openmodelicacompiler
  ADD_CUSTOM_COMMAND(OUTPUT ${OMC_OUTPUT}
                     COMMAND ${OMC_DEBUG} ${Flags} ${mos}
                     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                     COMMENT "Erzeuge Code fuer ${model} with ${OMC_DEBUG}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${model}codegen ALL DEPENDS ${OMC_OUTPUT})

  SET(OMC_FMU_CODE ${OMCTRUNCHOME}/c_runtime/fmu_model_interface.h
                   ${OMCTRUNCHOME}/c_runtime/fmiModelFunctions.h
				   ${OMCTRUNCHOME}/c_runtime/fmiModelTypes.h)
  
  ADD_LIBRARY(${model} SHARED ${OMC_OUTPUT} ${CSRC} ${OMC_FMU_CODE})
  TARGET_LINK_LIBRARIES(${model} sim c_runtime f2c sendData ModelicaExternalC)

  # Dependencies
  ADD_DEPENDENCIES(${model} ${model}codegen)
  
  IF(MODELS_INSTALL)
    INSTALL(TARGETS ${model} ARCHIVE DESTINATION ${MODELS_INSTALL_PATH})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/modelDescription.xml DESTINATION ${MODELS_INSTALL_PATH})
  ENDIF(MODELS_INSTALL)
#ENDFOREACH(model ${model_sources})
ENDMACRO(BUILDMODELFMUMOS)

# Check if example files are to be exported
SHOW_VARIABLE(MODELS_INSTALL BOOL "Install models" ON)

# If MODELS are to be exported, check where we should install them.
IF(MODELS_INSTALL)

  SHOW_VARIABLE(MODELS_INSTALL_PATH STRING
    "Output directory for installing models files" "${CMAKE_INSTALL_PREFIX}")
    
  IF(NOT MODELS_INSTALL_PATH)
    PRINT_WARNING("The example installation path is empty"
      "Example installation path was reset to its default value")
    SET(MODELS_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}" CACHE STRING
      "Output directory for installing example files" FORCE)
  ENDIF(NOT MODELS_INSTALL_PATH)

ELSE(MODELS_INSTALL)
   HIDE_VARIABLE(MODELS_INSTALL_PATH)
ENDIF(MODELS_INSTALL)

# Quellen und Header
SET(c_runtime_sources  boolean_array.c index_spec.c integer_array.c
                       memory_pool.c base_array.c real_array.c
					   string_array.c read_write.c utility.c
					   modelica_string.c bigden.c ddasrt.c  dlinpk.c
					   enorm.c   hybrd1.c  nelmead.c  qform.c
					   r1updt.c biglag.c  ddassl.c  dogleg.c
					   fdjac1.c  hybrj.c   newuoa.c   qrfac.c
					   trsapp.c daux.c    dlamch.c  dpmpar.c
					   hybrd.c   lsame.c   newuob.c   r1mpyq.c
					   update.c division.c java_interface.c
					   meta_modelica.c 
#					   meta_modelica_builtin.cpp
#					   meta_modelica_real.cpp meta_modelica_string_lit.c
					   rtclock.c ModelicaUtilities.c simulation_varinfo.c
					   read_matlab4.c read_csv.cpp)

SET(c_runtime_headers  blaswrap.h f2c.h integer_array.h memory_pool.h
                       modelica_string.h base_array.h inline.h real_array.h
					   string_array.h boolean_array.h index_spec.h matrix.h
					   modelica.h read_write.h utility.h meta_modelica.h
					   meta_modelica_builtin.h java_interface.h jni.h division.h
					   jni_md.h jni_md_solaris.h jni_md_windows.h fortran_types.h
#					   meta_modelica_builtin.h meta_modelica_real.h meta_modelica_string_lit.h
					   rtclock.h ModelicaUtilities.h simulation_varinfo.h read_matlab4.h read_csv.h
					   sendData/sendData.h)				 
						 
SET(sim_sources simulation_runtime.cpp simulation_init.cpp simulation_input.cpp 
                simulation_events.cpp linearize.cpp solver_main.cpp
				simulation_result_plt.cpp simulation_result_csv.cpp 
				simulation_result_mat.cpp simulation_delay.cpp tables.cpp options.cpp
				dgesv_aux.c  simulation_modelinfo.c)
	
SET(sim_headers simulation_runtime.h simulation_init.h simulation_input.h
                simulation_events.h linearize.h solver_main.h 
				simulation_result.h simulation_result_plt.h simulation_result_mat.h
				simulation_result_empty.h simulation_result_csv.h 
				simulation_delay.h tables.h options.h  
				simulation_inline_solver.h simulation_modelinfo.h )


# Library c_runtime
#ADD_DEFINITIONS(/Wall /O3  /ansi /pedantic)
ADD_DEFINITIONS(/DNO_INTERACTIVE_DEPENDENCY)
if(WIN32)
#add_definitions(/MT)
endif(WIN32)
ADD_LIBRARY(c_runtime ${c_runtime_sources} ${c_runtime_headers})
TARGET_LINK_LIBRARIES(c_runtime f2c)
# Library sim
if(WIN32)
#add_definitions(/MT)
endif(WIN32)
ADD_LIBRARY(sim ${sim_sources} ${sim_headers})
TARGET_LINK_LIBRARIES(sim c_runtime f2c ModelicaExternalC)

# Install
INSTALL(TARGETS c_runtime sim
		ARCHIVE DESTINATION lib)
		
INSTALL(FILES ${c_runtime_headers} DESTINATION include)

=== Compiler/susan_codegen/Makefile ===
.PHONY : all

OMC = ../../build/bin/omc

all : TplCodegen.mo
TplCodegen.mo : TplCodegen.tpl
	@echo " ** TplCodegen generation ** "
	$(OMC) +d=failtrace TplCodegen.tpl
	cp -puf TplCodegen.mo ../Template/
	@echo " "

test :
	@echo " ** Susan Test ** "
	$(OMC) +d=failtrace SusanTest.tpl

=== c_runtime/ModelicaExternalC/CMakeLists.txt ===
# Sources and Headers
set(ModelicaExternalC_sources ModelicaInternal.c ModelicaStrings.c ModelicaTablesImpl.c)

SET(ModelicaExternalC_headers ModelicaTables.h) 

# Library ModelicaExternalC
add_library(ModelicaExternalC  ${ModelicaExternalC_sources} ${ModelicaExternalC_headers})

# Install
INSTALL(TARGETS ModelicaExternalC
		ARCHIVE DESTINATION lib)
INSTALL(FILES f2c.h DESTINATION include)

=== c_runtime/libf2c/CMakeLists.txt ===
# Sources and Headers
set(MISC 
  f77vers.c i77vers.c main.c s_rnge.c abort_.c exit_.c getarg_.c iargc_.c
  getenv_.c signal_.c s_stop.c s_paus.c system_.c cabs.c 
  derf_.c derfc_.c erf_.c erfc_.c sig_die.c uninit.c)
set(POW pow_ci.c pow_dd.c pow_di.c pow_hh.c pow_ii.c pow_ri.c pow_zi.c pow_zz.c)
set(CX 	c_abs.c c_cos.c c_div.c c_exp.c c_log.c c_sin.c c_sqrt.c)
set(DCX	z_abs.c z_cos.c z_div.c z_exp.c z_log.c z_sin.c z_sqrt.c)
set(REAL r_abs.c r_acos.c r_asin.c r_atan.c r_atn2.c r_cnjg.c r_cos.c
  r_cosh.c r_dim.c r_exp.c r_imag.c r_int.c
  r_lg10.c r_log.c r_mod.c r_nint.c r_sign.c
  r_sin.c r_sinh.c r_sqrt.c r_tan.c r_tanh.c)
set(DBL	d_abs.c d_acos.c d_asin.c d_atan.c d_atn2.c
  d_cnjg.c d_cos.c d_cosh.c d_dim.c d_exp.c
  d_imag.c d_int.c d_lg10.c d_log.c d_mod.c
  d_nint.c d_prod.c d_sign.c d_sin.c d_sinh.c
  d_sqrt.c d_tan.c d_tanh.c)
set(INT i_abs.c 
  i_dim.c i_dnnt.c i_indx.c i_len.c i_mod.c i_nint.c i_sign.c
  lbitbits.c lbitshft.c)
set(HALF h_abs.c h_dim.c h_dnnt.c h_indx.c h_len.c h_mod.c h_nint.c h_sign.c)
set(CMP l_ge.c l_gt.c l_le.c l_lt.c hl_ge.c hl_gt.c hl_le.c hl_lt.c)
set(EFL	ef1asc_.c ef1cmc_.c)
set(CHAR f77_aloc.c s_cat.c s_cmp.c s_copy.c)
set(I77 backspac.c close.c dfe.c dolio.c due.c endfile.c err.c
  fmt.c fmtlib.c ftell_.c iio.c ilnw.c inquire.c lread.c lwrite.c
  open.c rdfmt.c rewind.c rsfe.c rsli.c rsne.c sfe.c sue.c
  typesize.c uio.c util.c wref.c wrtfmt.c wsfe.c wsle.c wsne.c xwsne.c)
set(QINT pow_qq.c qbitbits.c qbitshft.c ftell64_.c)
set(TIME dtime_.c etime_.c)

SET(f2c_headers f2c.h
			    fio.h
			    sysdep1.h
			    fmt.h
#			    math.h 
			    signal1.h
			    arith.h
			    lio.h
			    fp.h
			    rawio.h) 


# If you get an error compiling dtime_.c or etime_.c, try adding
# -DUSE_CLOCK to the CFLAGS assignment above; if that does not work,
# omit ${TIME} from OFILES  assignment below.

# To get signed zeros in write statements on IEEE-arithmetic systems,
# add -DSIGNED_ZEROS to the CFLAGS assignment below and add signbit.c
# to the end of the OFILES  assignment below.

# For INTEGER*8 support (which requires system-dependent adjustments to
# f2c.h), add ${QINT} to the OFILES  assignment below...
#add_executable(arithchk arithchk.c)
#if(UNIX)
#  target_link_libraries(arithchk m)
#endif()
#set_target_properties(arithchk PROPERTIES COMPILE_DEFINITIONS 
#  "NO_FPINIT;NO_LONG_LONG")
#ADD_CUSTOM_COMMAND(
#   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/arith.h
#   COMMAND arithchk > ${CMAKE_CURRENT_BINARY_DIR}/arith.h
#   DEPENDS arithchk
#   )


set(OFILES  ${MISC} ${POW} ${CX} ${DCX} ${REAL} ${DBL} ${INT} 
  ${HALF} ${CMP} ${EFL} ${CHAR} ${I77} ${TIME})
# Library f2c
if(WIN32)
  ADD_DEFINITIONS(/D_COMPLEX_DEFINED /DUSE_CLOCK /DMSDOS /DNO_ONEXIT /D_MSC_VER /D__STDC__ /D_CRT_SECURE_NO_DEPRECATE)
ELSE(WIN32)
  ADD_DEFINITIONS(-fPIC -DNON_UNIX_STDIO)
ENDIF(WIN32)
add_library(f2c  ${OFILES} ${f2c_headers})
#set_property(TARGET f2c PROPERTY PREFIX lib)

# Install
INSTALL(TARGETS f2c
		ARCHIVE DESTINATION lib)
INSTALL(FILES f2c.h DESTINATION include)

=== c_runtime/sendData/CMakeLists.txt ===
# Include Directorys

# find and setup Qt4 for this project
find_package(Qt4 REQUIRED)

INCLUDE_DIRECTORIES(${QT_QTCORE_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${QT_QTNETWORK_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${QT_QTGUI_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${QT_QTCORE_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${QT_QTGUI_INCLUDE_DIR}/../)

SET(QT_LIBRARIES "${QT_LIBRARIES}" ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QTNETWORK_LIBRARY} ${QT_QTDESIGNER_LIBRARY})

# Quellen und Header
SET(sendData_sources  sendData.cpp )
SET(sendData_headers  sendData.h)				 
						 

# Library sendData
#ADD_DEFINITIONS(/O2 /frtti /fexceptions /mthreads /Wall /DUNICODE /DQT_LARGEFILE_SUPPORT /DQT_NO_DEBUG /DQT_GUI_LIB /DQT_NETWORK_LIB /DQT_CORE_LIB /DQT_THREAD_SUPPORT)

ADD_LIBRARY(sendData ${sendData_sources} ${sendData_headers})
TARGET_LINK_LIBRARIES(sendData ${QT_LIBRARIES})

# Install
INSTALL(TARGETS sendData
		ARCHIVE DESTINATION lib)

=== Compiler/susan_codegen/SimCode/Makefile ===
.PHONY : all 

OMC = OPENMODELICAHOME=`pwd`/../../../build/ ../../../build/bin/omc +d=failtrace


all : SimCodeC.mo SimCodeCSharp.mo SimCodeFMU.mo Unparsing.mo SimCodeQSS.mo SimCodeCpp.mo SimCodeDump.mo



SimCodeC.mo : SimCodeC.tpl SimCodeTV.mo
	@echo " ** SimCodeC template compilation ** "
	$(OMC) $< > $@.log || (cat $@.log && false)
	cp -pf $@ ../../Template/
	@echo " "

SimCodeCSharp.mo : SimCodeCSharp.tpl SimCodeTV.mo
	@echo " ** SimCodeCSharp template compilation ** "
	$(OMC) $< > $@.log || (cat $@.log && false)
	cp -pf $@ ../../Template/
	@echo " "

SimCodeFMU.mo : SimCodeFMU.tpl SimCodeTV.mo
	@echo " ** SimCodeFMU template compilation ** "
	$(OMC) $< > $@.log || (cat $@.log && false)
	cp -pf $@ ../../Template/
	@echo " "	

Unparsing.mo : Unparsing.tpl SimCodeTV.mo
	@echo " ** Unparsing template compilation ** "
	$(OMC) $< > $@.log || (cat $@.log && false)
	cp -pf $@ ../../Template/
	@echo " "	

SimCodeDump.mo : SimCodeDump.tpl SimCodeTV.mo
	@echo " ** SimCodeDump template compilation ** "
	$(OMC) $< > $@.log || (cat $@.log && false)
	cp -pf $@ ../../Template/
	@echo " "	

SimCodeQSS.mo : SimCodeQSS.tpl SimCodeTV.mo
	@echo " ** SimCodeQSS template compilation ** "
	$(OMC) $< > $@.log || (cat $@.log && false)
	cp -pf $@ ../../Template/
	@echo " "	

SimCodeCpp.mo : SimCodeCpp.tpl SimCodeTV.mo
	@echo " ** SimCodeCpp template compilation ** "
	$(OMC) $< > $@.log || (cat $@.log && false)
	cp -pf $@ ../../Template/
	@echo " "

=== SimulationRuntime/cpp/Build/Makefile ===
# CMAKE generated file: DO NOT EDIT!
# Generated by "MinGW Makefiles" Generator, CMake Version 2.8

# Default target executed when no arguments are given to make.
default_target: all
.PHONY : default_target

#=============================================================================
# Special targets provided by cmake.

# Disable implicit rules so canoncical targets will work.
.SUFFIXES:

# Remove some rules from gmake that .SUFFIXES does not remove.
SUFFIXES =

.SUFFIXES: .hpux_make_needs_suffix_list

# Suppress display of executed commands.
$(VERBOSE).SILENT:

# A target that is always out of date.
cmake_force:
.PHONY : cmake_force

#=============================================================================
# Set environment variables for the build.

SHELL = cmd.exe

# The CMake executable.
CMAKE_COMMAND = "C:\Program Files\CMake 2.8\bin\cmake.exe"

# The command to remove a file.
RM = "C:\Program Files\CMake 2.8\bin\cmake.exe" -E remove -f

# The program to use to edit the cache.
CMAKE_EDIT_COMMAND = "C:\Program Files\CMake 2.8\bin\cmake-gui.exe"

# The top-level source directory on which CMake was run.
CMAKE_SOURCE_DIR = C:\Projekte\OMC\OpenModelica\SimulationRuntime\cpp\Source

# The top-level build directory on which CMake was run.
CMAKE_BINARY_DIR = C:\Projekte\OMC\OpenModelica\SimulationRuntime\cpp\Build

#=============================================================================
# Targets provided globally by CMake.

# Special rule for the target edit_cache
edit_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake cache editor..."
	"C:\Program Files\CMake 2.8\bin\cmake-gui.exe" -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : edit_cache

# Special rule for the target edit_cache
edit_cache/fast: edit_cache
.PHONY : edit_cache/fast

# Special rule for the target install
install: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	"C:\Program Files\CMake 2.8\bin\cmake.exe" -P cmake_install.cmake
.PHONY : install

# Special rule for the target install
install/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	"C:\Program Files\CMake 2.8\bin\cmake.exe" -P cmake_install.cmake
.PHONY : install/fast

# Special rule for the target install/local
install/local: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing only the local directory..."
	"C:\Program Files\CMake 2.8\bin\cmake.exe" -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local

# Special rule for the target install/local
install/local/fast: install/local
.PHONY : install/local/fast

# Special rule for the target install/strip
install/strip: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing the project stripped..."
	"C:\Program Files\CMake 2.8\bin\cmake.exe" -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip

# Special rule for the target install/strip
install/strip/fast: install/strip
.PHONY : install/strip/fast

# Special rule for the target list_install_components
list_install_components:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Available install components are: \"Unspecified\""
.PHONY : list_install_components

# Special rule for the target list_install_components
list_install_components/fast: list_install_components
.PHONY : list_install_components/fast

# Special rule for the target rebuild_cache
rebuild_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake to regenerate build system..."
	"C:\Program Files\CMake 2.8\bin\cmake.exe" -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : rebuild_cache

# Special rule for the target rebuild_cache
rebuild_cache/fast: rebuild_cache
.PHONY : rebuild_cache/fast

# The main all target
all: cmake_check_build_system
	$(CMAKE_COMMAND) -E cmake_progress_start C:\Projekte\OMC\OpenModelica\SimulationRuntime\cpp\Build\CMakeFiles C:\Projekte\OMC\OpenModelica\SimulationRuntime\cpp\Build\CMakeFiles\progress.marks
	$(MAKE) -f CMakeFiles\Makefile2 all
	$(CMAKE_COMMAND) -E cmake_progress_start C:\Projekte\OMC\OpenModelica\SimulationRuntime\cpp\Build\CMakeFiles 0
.PHONY : all

# The main clean target
clean:
	$(MAKE) -f CMakeFiles\Makefile2 clean
.PHONY : clean

# The main clean target
clean/fast: clean
.PHONY : clean/fast

# Prepare targets for installation.
preinstall: all
	$(MAKE) -f CMakeFiles\Makefile2 preinstall
.PHONY : preinstall

# Prepare targets for installation.
preinstall/fast:
	$(MAKE) -f CMakeFiles\Makefile2 preinstall
.PHONY : preinstall/fast

# clear depends
depend:
	$(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles\Makefile.cmake 1
.PHONY : depend

#=============================================================================
# Target rules for targets named Solver

# Build rule for target.
Solver: cmake_check_build_system
	$(MAKE) -f CMakeFiles\Makefile2 Solver
.PHONY : Solver

# fast build rule for target.
Solver/fast:
	$(MAKE) -f Solver\Implementation\CMakeFiles\Solver.dir\build.make Solver/Implementation/CMakeFiles/Solver.dir/build
.PHONY : Solver/fast

#=============================================================================
# Target rules for targets named Euler

# Build rule for target.
Euler: cmake_check_build_system
	$(MAKE) -f CMakeFiles\Makefile2 Euler
.PHONY : Euler

# fast build rule for target.
Euler/fast:
	$(MAKE) -f Solver\Euler\Implementation\CMakeFiles\Euler.dir\build.make Solver/Euler/Implementation/CMakeFiles/Euler.dir/build
.PHONY : Euler/fast

#=============================================================================
# Target rules for targets named Math

# Build rule for target.
Math: cmake_check_build_system
	$(MAKE) -f CMakeFiles\Makefile2 Math
.PHONY : Math

# fast build rule for target.
Math/fast:
	$(MAKE) -f Math\Implementation\CMakeFiles\Math.dir\build.make Math/Implementation/CMakeFiles/Math.dir/build
.PHONY : Math/fast

#=============================================================================
# Target rules for targets named SettingsFactory

# Build rule for target.
SettingsFactory: cmake_check_build_system
	$(MAKE) -f CMakeFiles\Makefile2 SettingsFactory
.PHONY : SettingsFactory

# fast build rule for target.
SettingsFactory/fast:
	$(MAKE) -f SettingsFactory\Implementation\CMakeFiles\SettingsFactory.dir\build.make SettingsFactory/Implementation/CMakeFiles/SettingsFactory.dir/build
.PHONY : SettingsFactory/fast

#=============================================================================
# Target rules for targets named Simulation

# Build rule for target.
Simulation: cmake_check_build_system
	$(MAKE) -f CMakeFiles\Makefile2 Simulation
.PHONY : Simulation

# fast build rule for target.
Simulation/fast:
	$(MAKE) -f SimManager\CMakeFiles\Simulation.dir\build.make SimManager/CMakeFiles/Simulation.dir/build
.PHONY : Simulation/fast

#=============================================================================
# Target rules for targets named System

# Build rule for target.
System: cmake_check_build_system
	$(MAKE) -f CMakeFiles\Makefile2 System
.PHONY : System

# fast build rule for target.
System/fast:
	$(MAKE) -f System\Implementation\CMakeFiles\System.dir\build.make System/Implementation/CMakeFiles/System.dir/build
.PHONY : System/fast

# Help Target
help:
	@$(CMAKE_COMMAND) -E echo "The following are some of the valid targets for this Makefile:"
	@$(CMAKE_COMMAND) -E echo "... all (the default if no target is provided)"
	@$(CMAKE_COMMAND) -E echo "... clean"
	@$(CMAKE_COMMAND) -E echo "... depend"
	@$(CMAKE_COMMAND) -E echo "... edit_cache"
	@$(CMAKE_COMMAND) -E echo "... install"
	@$(CMAKE_COMMAND) -E echo "... install/local"
	@$(CMAKE_COMMAND) -E echo "... install/strip"
	@$(CMAKE_COMMAND) -E echo "... list_install_components"
	@$(CMAKE_COMMAND) -E echo "... rebuild_cache"
	@$(CMAKE_COMMAND) -E echo "... Solver"
	@$(CMAKE_COMMAND) -E echo "... Euler"
	@$(CMAKE_COMMAND) -E echo "... Math"
	@$(CMAKE_COMMAND) -E echo "... SettingsFactory"
	@$(CMAKE_COMMAND) -E echo "... Simulation"
	@$(CMAKE_COMMAND) -E echo "... System"
.PHONY : help



#=============================================================================
# Special targets to cleanup operation of make.

# Special rule to run CMake to check the build system integrity.
# No rule that depends on this can have commands that come from listfiles
# because they might be regenerated.
cmake_check_build_system:
	$(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles\Makefile.cmake 0
.PHONY : cmake_check_build_system

=== SimulationRuntime/cpp/Source/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(CppSolverInterface)

# on windows  boost,blas,lapack from omdev is used else the installed versions are used
IF( WIN32 )
SET(ENV{BOOST_ROOT} $ENV{OMDEV}"/lib/3rdParty/boost_1_45_0/")
set(BLAS_blas_LIBRARY $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/blas.dll CACHE FILEPATH "Blas library")
set(LAPACK_lapack_LIBRARY  $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/lapack.dll CACHE FILEPATH "Lapack library")
ENDIF( WIN32 )

SET(Boost_USE_STATIC_LIBS OFF)
SET(Boost_USE_MULTITHREADED ON)
SET(Boost_USE_STATIC_RUNTIME OFF)
find_package(Boost 1.45.0 COMPONENTS serialization REQUIRED )
find_package( Lapack REQUIRED)

link_directories ( ${Boost_LIBRARY_DIRS} )
include_directories ( ${Boost_INCLUDE_DIRS} )



include_directories ("${PROJECT_SOURCE_DIR}")
include_directories ("${PROJECT_BINARY_DIR}")
#add solver default implemention project
add_subdirectory (Solver/Implementation)
#add  Euler solver project
add_subdirectory (Solver/Euler/Implementation)
#add  math project
add_subdirectory (Math/Implementation)
#add  settings factory project
add_subdirectory (SettingsFactory/Implementation)
#add  simmanager project
add_subdirectory (SimManager)
#add  system default implementation project
add_subdirectory (System/Implementation)
  

GET_TARGET_PROPERTY(libEuler Euler LOCATION)
GET_FILENAME_COMPONENT(libEulerName ${libEuler} NAME)

GET_TARGET_PROPERTY(libSetFactory SettingsFactory LOCATION)
GET_FILENAME_COMPONENT(libSetFactoryName ${libSetFactory} NAME)
set (EULER_LIB ${libEulerName})
set (SETTINGSFACTORY_LIB ${libSetFactoryName})
# configure a header file to pass some library names
# to the source code which are used to dynamic load and instantiate 
configure_file (
  "${PROJECT_SOURCE_DIR}/LibrariesConfig.h.in"
  "${PROJECT_BINARY_DIR}/LibrariesConfig.h"
  )

=== Compiler/susan_codegen/SimCode/GenTest/Makefile ===
.PHONY : all tplmode csharp cppOrig QHP beatheart csCopy tst HumMod

OMC = ../../../../build/bin/omc.exe
#OMC = OPENMODELICAHOME=`pwd`/../../../../../build/ ../../../../../build/bin/omc
#OMC = OPENMODELICAHOME=D:/Modelica/OpenModelica/OpenModelica_trunk/build/ ../../../../../build/bin/omc

#OMC = /d/Modelica/_modely/MM_for_debug/omc.exe
#OMC = /c/OpenModelica1.4.5/bin/omc.exe
HumModDir = "/d/Modelica/_modely/HumModOMC/OMC"
ModelsNET = "/d/Modelica/Bodylight/Solvers/Compiled Solvers/Simulation/ModelsDotNet/"
#all :  tplmode  csharp  cppOrig
all :  QHP csCopy
#all : csharp csCopy
#all :  tst
#all :  cppOrig

tst:
	#(cd ../../../../testsuite/mosfiles/ && ../../build/bin/omc.exe BuiltinMath.mos 2>&1)
	(cd ../../../../testsuite/mofiles/ && ../../build/bin/omc.exe ArrayAssignWholeDim.mo > ArrayAssignWholeDim.mof  2>&1)
	(cd ../../../../testsuite/mofiles/ && ../../build/bin/omc.exe VectorTest.mo > VectorTest.mof  2>&1)
	
tplmode : 
	@echo " ** Generate TrapezTest Test ** "
	(cd TrapezTest && ../$(OMC) +d=tplmode,tpl2,tplgen_ generate.mos)
	#@echo " ** Generate RightHeartStarling Test C/C++ target ** "
	#(cd RightHeartStarling && ../$(OMC) +d=tplmode,tpl2,tplgen_ generate.mos)

csharp :
	@echo " ** Generate RightHeartStarling Test CSharp target ** "
	(cd RightHeartStarling && ../$(OMC) +d=tplmode,CSharp generate.mos)
	#@echo " ** Generate TrapezUnderground Test CSharp target ** "
	#(cd TrapezUnderground && ../$(OMC) +d=tplmode,CSharp generate.mos)

cppOrig :
	#@echo " ** Generate TrapezTest original original C/C++ target  ** "
	#(cd TrapezTest && ../$(OMC) +d=no_tplmode generate.mos)
	#@echo " ** Simulate TrapezUnderground Test original C/C++ target ** "
	#(cd TrapezUnderground && ../$(OMC) +d=no_tplmode simulate.mos)
	#@echo " ** Simulate RightHeartStarling original C/C++   ** "
	#(cd RightHeartStarling && ../$(OMC) +d=no_tplmode simulate.mos)
	@echo " ** Simulate QHP  original C/C++   ** "
	(cd QHP && ../$(OMC) +showErrorMessages +d=failtrace simulate.mos > debug-trace.txt 2>&1)

QHP:
	@echo " ** Simulate QHP  original C/C++   ** "
	#(cd QHP && ../$(OMC) +showErrorMessages +d=perfTimes,failtrace simulate.mos > debug-trace-C.txt 2>&1)
	#(cd QHP && ../$(OMC) +showErrorMessages +d=perfTimes simulate.mos > debug-trace-C.txt 2>&1)
	(cd QHP && ../$(OMC) +d=perfTimes,scodeFlatten simulate.mos > debug-trace-C.txt 2>&1)
	@echo " ** Generate QHP CSharp target ** "
	(cd QHP && ../$(OMC) +showErrorMessages +d=perfTimes,CSharp generate.mos > debug-trace-CSharp.txt 2>&1)

HumMod:
	@echo " ** Simulate HumMod OMC C/C++   ** "
	#(cd QHP && ../$(OMC) +showErrorMessages +d=perfTimes,failtrace simulate.mos > debug-trace-C.txt 2>&1)
	#(cd QHP && ../$(OMC) +showErrorMessages +d=perfTimes simulate.mos > debug-trace-C.txt 2>&1)
	(cd QHP && $(OMC) +d=perfTimes simulate.mos > debug-trace-C.txt 2>&1)
	#@echo " ** Generate QHP CSharp target ** "
	#(cd QHP && ../$(OMC) +showErrorMessages +d=perfTimes,CSharp generate.mos > debug-trace-CSharp.txt 2>&1)
	

csCopy:
	#(cp -pf ./QHP/Conlon_circulatoryVAD.cs  "/d/Modelica/_svn_Solvers/Compiled Solvers/Simulation/ModelsDotNet/")
	#(cp -pf ./QHP/QHP_Blood_BlooodVolume_ExpandableConnectorPatch_T.cs  "/d/Modelica/_svn_Solvers/Compiled Solvers/Simulation/ModelsDotNet/")
	#(cp -pf ./QHP/QHP_Electrolytes_ExpandableConnectorPatch_T.cs  "/d/Modelica/_svn_Solvers/Compiled Solvers/Simulation/ModelsDotNet/")
	#(cp -pf ./QHP/QHP_test_TestRedCells.cs  "/d/Modelica/_svn_Solvers/Compiled Solvers/Simulation/ModelsDotNet/")
	#(cp -pf TrapezUnderground/*.cs  $(ModelsNET))
	#(cp -pf RightHeartStarling/*.cs $(ModelsNET))
	(cp -pf ./QHP/*.cs  $(ModelsNET))
	
#RightHeartStarling/RightHeartStarling.cpp :  RightHeartStarling/RightHeartStarling.mo 
#	@echo " ** Generate RightHeartStarling original cpps  ** "
#	(cd RightHeartStarling && ../$(OMC) +d=no_tplmode generate.mos)

=== SimulationRuntime/cpp/Source/SimManager/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(SimManager)
add_executable(Simulation  Configuration.cpp Main.cpp  )
target_link_libraries( Simulation ${Boost_LIBRARIES})


install (TARGETS Simulation DESTINATION bin)

=== debian/changelog ===
openmodelica (8719-1) unstable; urgency=low

  * Automatic subversion build
 -- OpenModelica Build System <build@openmodelica.org>  Wed, 20 Apr 2011 16:45:18 +0200

=== debian/control ===
Source: openmodelica
Section: math
Priority: optional
Maintainer: OpenModelica Build System <build@openmodelica.org>
Build-Depends: debhelper (>= 7.0.0),
 libsqlite3-dev,
 libssl-dev (>= 0.9.8g),
 libreadline-dev,
 libqt4-dev (>= 4.4.3),
 libqwt5-qt4-dev (>= 5.1.1),
 libsoqt4-dev,
 libcoin60-dev (>= 3.1.3),
 liblpsolve55-dev (>= 5.5.0.10),
 rml-mmc (>= 204),
 openjdk-6-jdk | sun-java6-jdk,
 libomniorb4-dev,
 omniidl4,
 gnuplot,
 xsltproc,
 flex,
 paradiseo,
 bison,
 libf2c2-dev,
 autoconf
Standards-Version: 3.8.4

Package: openmodelica
Section: math
Architecture: any
Depends: omc,
 omlibrary-msl31,
 omshell,
 omshell-terminal,
 omnotebook,
 drmodelica,
 drcontrol,
 omedit,
 omoptim,
 ${misc:Depends}
Description: A complete Modelica environment
 The goal of the project is to create a complete Modelica modeling, compilation
 and simulation environment based on free software distributed in binary and
 source code form.
 .
 This package is a Debian metapackage. After installation this package can be
 removed. This metapackage pulls in the following OpenModelica packages:
 .
 1. Package omc the OpenModelica Compiler/Interpreter (omc)
 2. Package omshell the OpenModelica Shell (OMShell)
 3. Package omshell-terminal the OpenModelica Shell-terminal (OMShell-terminal)
 4. Package omlibrary-msl31 the Modelica Standard Library version 3.1
 5. Package omnotebook the OpenModelica Notebook, with DrModelica and DrControl
 6. Package omedit, a Modelica connection editor for OpenModelica
 7. Package omoptim, a tool for optimization of Modelica models

Package: omc
Section: math
Architecture: any
Depends: sun-java6-jre | openjdk-6-jre,
 build-essential,
 libqt4-dev,
 gnuplot,
 xsltproc,
 libf2c2-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Description: The OpenModelica Compiler
 This is the core of the OpenModelica project. It can be used stand-alone as
 a compiler. It is recommended to use it together with an OpenModelica client,
 such as OMShell (textual interface), OMNotebook (for teaching purposes)
 or OMEdit (graphical modeling).

Package: omedit
Section: math
Architecture: any
Depends: omc,
 omlibrary-msl31,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A Modelica connection editor for OpenModelica
 OMEdit is still in active development. Please try it out and give feedback.

Package: omoptim
Section: math
Architecture: any
Depends: omc,
 gnuplot,
 omlibrary-msl31,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A Modelica optimization tool for OpenModelica

Package: omnotebook
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: drmodelica,
 drcontrol
Description: A Mathematica-style Notebook for OpenModelica

Package: drmodelica
Section: math
Architecture: any
Depends: omnotebook,
 ${shlibs:Depends},
 ${misc:Depends}
Description: An OMNotebook course in the Modelica language
 The course is based on Peter Fritzson's book
 “Principles of Object-Oriented Modeling and Simulation with Modelica 2.1”.

Package: drcontrol
Section: math
Architecture: any
Depends: omnotebook,
 ${shlibs:Depends},
 ${misc:Depends}
Description: An OMNotebook course in basic control theory

Package: omshell-terminal
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A text-based interface to OpenModelica (based on readline)

Package: omshell
Section: math
Architecture: any
Depends: omc,
 omshell-terminal,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A text-based interface to OpenModelica (based on Qt)

Package: omlibrary-all
Section: math
Architecture: any
Depends: omlibrary-msl16,
 omlibrary-msl221,
 omlibrary-msl31,
 omlibrary-msl32,
 omlibrary-biochem,
 omlibrary-additions,
 omlibrary-simplefluid,
 ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Library Collection (All)
 * Modelica Standard Library versions 1.6, 2.2, 3.1, 3.2
 * ModelicaAdditions
 * BioChem
 * SimpleFluid

Package: omlibrary-msl16
Section: math
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Library Collection (MSL 1.6)
 Modelica Standard Library version 1.6

Package: omlibrary-msl221
Section: math
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Library Collection (MSL 2.2.1)
 Modelica Standard Library version 2.2.1

Package: omlibrary-msl31
Section: math
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Library Collection (MSL 3.1)
 Modelica Standard Library version 3.1

Package: omlibrary-msl32
Section: math
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Library Collection (MSL 3.2)
 Modelica Standard Library version 3.2

Package: omlibrary-biochem
Section: math
Architecture: any
Depends: omlibrary-msl221,
 ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Library Collection (BioChem)
 BioChem library for MSL 2.2.1

Package: omlibrary-additions
Section: math
Architecture: any
Depends: omlibrary-msl16,
 ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Library Collection (ModelicaAdditions)
 Modelica Additions to MSL 1.6 (most functionality exists elsewhere in MSL 3.1)

Package: omlibrary-simplefluid
Section: math
Architecture: any
Depends: omlibrary-msl221,
 ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Library Collection (SimpleFluid)
 SimpleFluid library for MSL 2.2.1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# OpenModelica debian/rules that uses debhelper.
# Based on a sample file with GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ARCH ?= $(shell uname -m | sed s/i[0-9]86/x86/)

# Some variables to install binaries under debian/tmp
DEST   = $(CURDIR)/debian/tmp
SRCD   = $(CURDIR)

# Compile omc with sendData.cpp and not with humbug.cpp
export QTHOME=/usr

CFLAGS = -Wall

CXX = g++

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O3
endif
ifeq ("x86","$(ARCH)")
	CFLAGS += -ffloat-store -msse -mfpmath=sse
else
	CFLAGS += -msse2 -mfpmath=sse
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

config.status: configure
	dh_testdir

	# Add here commands to configure the package.
	RMLHOME=/usr CXX="$(CXX)" CFLAGS="$(CFLAGS)" ./configure \
	--host=$(DEB_HOST_GNU_TYPE) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--prefix=/usr \
	--with-omniORB=/usr \
	--with-static-lpsolve=/usr \
        --with-sendData-Qt \
	--with-Coin \
	--disable-rml-trace

build: build-stamp

build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) omc mosh omlibrary
	# Qtclients will start make omc again
	# This is a good thing as Susan will then run and regenerate SimCodeC
	ANTLRHOME=/usr $(MAKE) qtclients;
	/usr/bin/time -f "== Testsuite wall-time: %e" $(MAKE) -C testsuite/ > ./build/share/doc/omc/testsuite.txt 2>&1
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs -popenmodelica -Pdebian/tmp

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install DESTDIR=$(DEST)

	# Remove extra copyright files
	cd $(DEST)/usr/share/doc/omc/; rm antlr_license.txt ptplot_license.txt
	
	dh_install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install
	dh_installmenu
	dh_installmime
	dh_installman
	dh_link
	dh_strip
	dh_compress -X.pdf -X.onb -X.c -X.h -X.mo -X.mos
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
